$TYPECHECK ON
$OPTIMIZE ON
$INCLUDE <RapidQ2.inc>
$INCLUDE <QGL.inc>
$RESOURCE ICO as "SecondTGA.ico"
$OPTION ICON "SecondTGA.ico"

declare sub MakeMods
declare sub initfx
declare sub redraw
declare sub wipeoff
declare sub sizeit
declare sub OpenBMP
declare sub ZoomP
declare sub ZoomM
declare sub elP
declare sub elM
declare sub LetMouse
declare sub stpr
declare sub strt
declare sub LoadDXF
declare sub LoadDXFd
declare sub LoadTGAd
declare sub LoadTGA
declare sub Refr
declare sub Rest
declare sub Solid
declare sub Wire

DIM Registry AS QRegistry, InstallDir as String
DIM DXFCod% as Integer, s$ as string, Vrtx% as long, OffDXF as long, OutRan as long
DIM DXFf AS QFileStream, TGAf AS QFileStream, memx as long, memy as long
DIM i as integer 
DIM Px% as integer, Py% as integer
dim BoxObj(0 TO 64000) as single
dim io as long, iv as long, cp as long, Extra as long
dim TexCoords(0 TO 64000) as single
DIM RedC! as single, GrnC! as single, BleC! as single
DIM RedC2! as single, GrnC2! as single, BleC2! as single
DIM RedC3! as single, GrnC3! as single, BleC3! as single
DIM RedC4! as single, GrnC4! as single, BleC4! as single
TYPE CadPnt
 Rx(0 to 128) AS single
 Gy(0 to 128) AS single
 Bz(0 to 128) AS single
END TYPE
DIM Pnt(0 to 128) as CadPnt, PntC as long
dim flagF as long
dim DXFLoaded$ as string, TGALoaded$ as string, Texture$ as string, distance as double, elev as double, stopper as long, rotV as long
dim MaxXcad as single, MinXcad as single, dxfXcenter as single, initnum as long
dim MaxYcad as single, MinYcad as single, dxfYcenter as single, reduce as single, maxspace as single
distance=-3.5 : elev=1.75 : stopper=1 : rotV=1
DIM OpenDlog as QOpenDialog

defsng xrot=0.0 : defsng yrot=0.5 : defsng zrot=0.0
DIM Texture% AS GLuint : Texture%=0
DIM GL AS QGL

TYPE TGA_h
 identsize       As String * 1
 colourmaptype   As String * 1
 imagetype       As String * 1
 colourmapstart  As Short
 colourmaplength As Short
 colourmapbits   As String * 1
 xstart          As Short
 ystart          As Short
 width           As Short
 height          As Short
 bits            As String * 1
 descriptor      As String * 1
END TYPE
DIM MyTGA As TGA_h, getmouse as long

Const HKEY_CURRENT_USER=&H80000001
Registry.RootKey=HKEY_CURRENT_USER
$ESCAPECHARS OFF
IF Registry.KeyExists("Software\SecondTGA")=1 THEN 
 Registry.OpenKey("Software\SecondTGA",0) : DoEvents
 InstallDir=Registry.ReadString("InstallDir")+"\"
 Registry.CloseKey
ELSE
 InstallDir=Curdir$+"\"
END IF

IF LEN(COMMAND$(1))<>0 THEN
 IF lcase$(right$(COMMAND$(1),4))=".dxf" then 
  DXFLoaded$=COMMAND$(1)
 ELSEIF lcase$(right$(COMMAND$(1),4))=".tga" then
  TGALoaded$=COMMAND$(1)
 END IF
ELSE
 DXFLoaded$=InstallDir+"default.DXF"
END IF



Texture$=InstallDir+"ritmo8.bmp"
dim littfont as QFont : littfont.size=8 : littfont.name="Tahoma"

create tmx as QTimer
 interval=1
 enabled =1
 onTimer =redraw
end create

Dim sphobj AS GLUquadricObj, Bmodel as glInt,Qmodel as glInt

CREATE fx As QFORM
  Caption="SecondTGA 3Dview Vers.0.4i"
  Top=0
  left= 0
  width=640
  height=500
  AutoScroll=0
  onPaint=redraw
  onResize=sizeit
  onShow=initfx
  font=littfont
  create Panel as QPanel
   color=&hd8e9ec
   height=29+31
   Width=fx.clientwidth
   BevelWidth=0
   BevelInner=0
   BevelOuter=0
   borderstyle=0
   Create Butn0 as QButton
    Caption="Alza Punto di Vista"
    OnMOuseDown=elP
    OnMOuseUp=LetMouse
    Top=4
    Left=6
    Height=24
   end create
   Create Butn1 as QButton
    Caption="Abbassa Punto di Vista"
    OnMOuseDown=elM
    OnMOuseUp=LetMouse
    Top=4
    Height=24
   end create
   Create Butn2 as QButton
    Caption="Avvicina"
    OnMOuseDown=ZoomP
    OnMOuseUp=LetMouse
    Top=4
    Height=24
   end create
   Create Butn3 as QButton
    Caption="Allontana"
    OnMOuseDown=ZoomM
    OnMOuseUp=LetMouse
    Top=4
    Height=24
   end create
   Create Butn3a as QButton
    Caption="Texture solida"
    OnClick=Solid
    Top=4
    Height=24
   end create
   Create Butn4 as QButton
    Caption="On/Off Rotazione"
    OnClick=Stpr
    Top=6+26
    Height=24
   end create
   Create Butn5 as QButton
    Caption="Inverti Rotazione"
    onClick=strt
    Top=6+26
    Height=24
   end create
   Create Butn6 as QButton
    Caption="Ricarica tutto"
    onClick=Refr
    Top=6+26
    Height=24
   end create
   Create Butn7 as QButton
    Caption="Reset Punto di Vista"
    onClick=Rest
    Top=6+26
    Height=24
   end create
   Create Butn7a as QButton
    Caption="Wireframe"
    onClick=Wire
    Top=6+26
    Height=24
   end create
  end create
  create fxmnu as QMAINMENU
    create fxshp as QMENUITEM
      caption="File"
      create ltga as QMENUITEM
        caption="Carica Sculpt TGA"
        onClick=LoadTGAd
      end create
      create ldxf as QMENUITEM
        caption="Carica DXF"
        onClick=LoadDXFd
      end create
      create ltext as QMENUITEM
        caption="Carica texture BMP"
        onClick=OpenBMP
      end create
      create brk as QMENUITEM
        caption="-"
      end create
      create xit as QMENUITEM
        caption="Chiudi"
        onClick=wipeoff
      end create
    end create
  end create
end create

' main program
application.title="SecondTGA 3D"
fx.ShowModal
end

'user procedures
sub initfx
    flagF=SetFocus(panel.handle)
    GL.Init(fx)
    GL.MipMap=GL_LINEAR_MIPMAP_LINEAR  'or GL_NEAREST_MIPMAP_NEAREST or GL_LINEAR_MIPMAP_NEAREST,or GL_NEAREST_MIPMAP_LINEAR  
    Texture%=GL.CreateTextureFromFile(Texture$)
    IF Texture%=0 THEN fx.Close

	glEnable GL_TEXTURE_2D                         '' Enable Texture Mapping ( NEW )
	glShadeModel GL_SMOOTH                         '' Enable Smooth Shading
	glClearColor 0.5, 0.5, 0.5, 1.0                '' grey Background
 	glClearDepth 1.0                               '' Depth Buffer Setup
'	glEnable GL_DEPTH_TEST                         '' Enables Depth Testing
'	glDepthFunc GL_LEQUAL                          '' The Type Of Depth Testing To Do

' Translucency, Blending
' glBlendFunc(GL_SRC_ALPHA, GL_ONE)
' glEnable(GL_BLEND)
' glEnable(GL_CULL_FACE)
' glCullFace(GL_FRONT) ' This creates problem in glPrint

' light moves with translation, rotation of modelview
 '   DEFSNG LightPos(3) = {0.5, 0.5, 3.0, 1.0}
  '  glLightfv(GL_LIGHT0, GL_POSITION, LightPos(0))
   ' glEnable(GL_LIGHTING)
  '  glEnable(GL_LIGHT0)

     DEFSNG Material(2) = {0.1745, 0.01175, 0.01175}
     glMaterialfv (GL_FRONT, GL_AMBIENT, Material(0))
     DEFSNG DiffMaterial(0) = {0.61424, 0.04136, 0.04136}
     glMaterialfv (GL_FRONT, GL_DIFFUSE, DiffMaterial(0))
     DEFSNG SpecMaterial(0) = {0.727811, 0.626959, 0.626959}
     glMaterialfv (GL_FRONT, GL_SPECULAR, SpecMaterial(0))
     glMaterialf (GL_FRONT, GL_SHININESS, 0.6*128.0)
     
    GL.FogEnabled = 0
    GL.FogMode = GL_EXP
    GL.FogColor(0.5, 0.5, 0.5)
    GL.SetFogParams(Gl.Front, Gl.Back, 0.52)
    glClearColor 0,0,0,1 '(0.5, 0.5, 0.5, 1.0)   ' fog color

	'glMatrixMode GL_MODELVIEW                      '' Select The Modelview Matrix
	glMatrixMode GL_POLYGON_MODE                      '' Select The Modelview Matrix
	glLoadIdentity                                 '' Reset The Modelview Matrix
    MakeMods
    redraw
end sub

sub sizeit
 panel.Width=fx.clientwidth
 GL.Resize(fx.clientWidth, fx.clientHeight)
 doevents : Butn0.Width=(Panel.Width-(6*4))/5
 doevents : Butn1.Left=Butn0.Left+Butn0.Width+4 : Butn2.Left=Butn1.Left+Butn0.Width+4
 doevents : Butn3.Left=Butn2.Left+Butn0.Width+4 : Butn3a.Left=Butn3.Left+Butn0.Width+4 
 doevents : Butn4.Left=Butn0.Left : Butn5.Left=Butn1.Left
 doevents : Butn6.Left=Butn2.Left : Butn7.Left=Butn3.Left
 doevents : Butn7a.Left=Butn3a.Left
 doevents : Butn1.Width=Butn0.Width : Butn2.Width=Butn0.Width : Butn3.Width=Butn0.Width 
 doevents : Butn3a.Width=Butn0.Width : Butn4.Width=Butn0.Width
 doevents : Butn5.Width=Butn0.Width : Butn6.Width=Butn0.Width
 doevents : Butn7.Width=Butn0.Width : Butn7a.Width=Butn0.Width

end sub

sub redraw
 glClear GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT      '' Clear Screen And Depth Buffer
 glPushMatrix
 glMatrixMode GL_MODELVIEW                      '' Select The Modelview Matrix
 glLoadIdentity                                 '' Reset The Modelview Matrix
 gluLookAt(0,elev,distance,  0,.3,0,   0,1,0)
 
 
 IF stopper=1 and getmouse=0 then
  IF RotV=1 THEN
   yrot=yrot+0.5
  ELSE
   yrot=yrot-0.5
  END IF
 END IF
    
	glTranslatef 0.00, 0.00, zrot                          '' translate before rotate
	glRotatef xrot,1.0, 0.0, 0.0                            '' Rotate On The X Axis
      glRotatef yrot,0.0, 1.0, 0.0                            '' Rotate On The Y Axis
	glRotatef zrot,0.0, 0.0, 1.0                            '' Rotate On The Z Axis

	glBindTexture GL_TEXTURE_2D, Texture%                 '' Select new Texture if needed
'     glColor3f 1.0, 1.0 ,1.0                                 'set all vertices to white
  glCallList(Bmodel)
  glPopMatrix
  GL.Flip
end sub

sub wipeoff
 GL.Close : fx.close
end sub

SUB MakeMods
 glEnable GL_DEPTH_TEST          '' Enables Depth Testing for cube
 glDepthFunc GL_LEQUAL            '' The Type Of Depth Testing To Do  
 zrot=0    
 If TGALoaded$="" then 
  LoadDXF 
 else
  LoadTGA
 end if

 cp=0

for iv = 0 to 31
 for io = 0 to 31
  TexCoords(cp)   = io/32
  TexCoords(cp+1) = iv/32
  TexCoords(cp+2) = (io+1)/32
  TexCoords(cp+3) = iv/32
  TexCoords(cp+4) = (io+1)/32
  TexCoords(cp+5) = (iv+1)/32
  TexCoords(cp+6) = io/32
  TexCoords(cp+7) = (iv+1)/32
  cp=cp+8
 next 
next

    Bmodel = glGenLists( 1 )
    glNewList(Bmodel, GL_COMPILE)
	glBegin GL_QUADS
     '  for i = 0 to (1024)*4
       for i = 0 to (initnum)*4
               glTexCoord2fv TexCoords(i*2)
               glVertex3fv   BoxObj(i*3)
       next i
    glEnd
    glEndList
END SUB


SUB LoadDXF
 i=0 : DXFf.Open(DXFLoaded$,0) : s$=DXFf.ReadLine
 IF DXFf.ReadLine<>"[Written by SecondTGA(c)imitidicthulhu]" THEN 
  Extra=1 : Showmessage "Attenzione: si sta tendando di caricare un file DXF non generato come sculpty da SecondTGA."
 END IF
 WHILE s$<>"ENTITIES"
  s$=DXFf.ReadLine
  IF s$="$EXTMIN" THEN
   s$=DXFf.ReadLine : MinXcad=Val(DXFf.ReadLine)
   s$=DXFf.ReadLine : MinYcad=Val(DXFf.ReadLine)   
  END IF
  IF s$="$EXTMAX" THEN
   s$=DXFf.ReadLine : MaxXcad=Val(DXFf.ReadLine)
   s$=DXFf.ReadLine : MaxYcad=Val(DXFf.ReadLine)   
  END IF
 WEND
 IF Extra=1 THEN
  if (MaxXcad-MinXcad)>(MaxYcad-MinYcad) then maxspace=(MaxXcad-MinXcad) else maxspace=(MaxYcad-MinYcad)
  dxfXcenter=(MinXcad+MaxXcad)/2 : dxfYcenter=(MinYcad+MaxYcad)/2
  if dxfXcenter>dxfYcenter THEN Reduce=dxfXcenter Else Reduce=dxfYcenter
  reduce=2.56/maxspace
  IF reduce<>0 THEN
   dxfXcenter=dxfXcenter*reduce
   dxfYcenter=dxfYcenter*reduce
  ELSE
   reduce=5
  END IF
 END IF

 
L_dxf: s$=DXFf.ReadLine
      IF s$="3DFACE" THEN GOSUB 110
      IF s$="EOF" THEN 
       DXFf.Close
       initnum=i/12
       'showmessage str$(initnum)
       'showmessage str$(OutRan)
       EXIT SUB
      END IF
      GOTO L_dxf
110: s$=DXFf.ReadLine
     DXFCod%=VAL(s$)
     IF DXFCod%=10 THEN
      GOTO 120
     ELSE
      s$=DXFf.ReadLine
      GOTO 110
     END IF
120:  
      IF Extra=0 THEN BleC!=CINT(VAL(DXFf.ReadLine)) ELSE BleC!=VAL(DXFf.ReadLine)'x
      IF BleC!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : BleC!=255
      END IF
      IF BleC!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : BleC!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)
      IF Extra=0 THEN GrnC!=CINT(VAL(DXFf.ReadLine)) ELSE GrnC!=VAL(DXFf.ReadLine)'y
      IF GrnC!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : GrnC!=255
      END IF
      IF GrnC!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : GrnC!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)
      IF Extra=0 THEN RedC!=CINT(VAL(DXFf.ReadLine)) ELSE RedC!=VAL(DXFf.ReadLine)'z
      IF RedC!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : RedC!=255
      END IF
      IF RedC!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : RedC!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)

      IF Extra=0 THEN BleC2!=CINT(VAL(DXFf.ReadLine)) ELSE BleC2!=VAL(DXFf.ReadLine)'x
      IF BleC2!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : BleC2!=255
      END IF
      IF BleC2!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : BleC2!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)
      IF Extra=0 THEN GrnC2!=CINT(VAL(DXFf.ReadLine)) ELSE GrnC2!=VAL(DXFf.ReadLine)'y
      IF GrnC2!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : GrnC2!=255
      END IF
      IF GrnC2!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : GrnC2!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)
      IF Extra=0 THEN RedC2!=CINT(VAL(DXFf.ReadLine)) ELSE RedC2!=VAL(DXFf.ReadLine)'z
      IF RedC2!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : RedC2!=255
      END IF
      IF RedC2!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : RedC2!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)
      
      IF Extra=0 THEN BleC3!=CINT(VAL(DXFf.ReadLine)) ELSE BleC3!=VAL(DXFf.ReadLine)'x
      IF BleC3!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : BleC3!=255
      END IF
      IF BleC3!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : BleC3!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)
      IF Extra=0 THEN GrnC3!=CINT(VAL(DXFf.ReadLine)) ELSE GrnC3!=VAL(DXFf.ReadLine)'y
      IF GrnC3!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : GrnC3!=255
      END IF
      IF GrnC3!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : GrnC3!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)
      IF Extra=0 THEN RedC3!=CINT(VAL(DXFf.ReadLine)) ELSE RedC3!=VAL(DXFf.ReadLine)'z
      IF RedC3!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : RedC3!=255
      END IF
      IF RedC3!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : RedC3!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)

'if DXFCod%<>13 then showmessage "hi"

      IF Extra=0 THEN BleC4!=CINT(VAL(DXFf.ReadLine)) ELSE BleC4!=VAL(DXFf.ReadLine)'x
      IF BleC4!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : BleC4!=255
      END IF
      IF BleC4!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : BleC4!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)
      IF Extra=0 THEN GrnC4!=CINT(VAL(DXFf.ReadLine)) ELSE GrnC4!=VAL(DXFf.ReadLine)'y
      IF GrnC4!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : GrnC4!=255
      END IF
      IF GrnC4!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : GrnC4!=0
      END IF
      DXFCod%=VAL(DXFf.ReadLine)
      IF Extra=0 THEN RedC4!=CINT(VAL(DXFf.ReadLine)) ELSE RedC4!=VAL(DXFf.ReadLine)'z
      IF RedC4!>255 AND Extra=0 THEN
       OutRan=OutRan+1 : RedC4!=255
      END IF
      IF RedC4!<0 AND Extra=0 THEN
       OutRan=OutRan+1 : RedC4!=0
      END IF

IF Extra=0 THEN
  BoxObj(i)=-(BleC!-128)/100
  BoxObj(i+1)=(RedC!-128)/100
  BoxObj(i+2)=(GrnC!-128)/100
  BoxObj(i+3)=-(BleC2!-128)/100
  BoxObj(i+4)=(RedC2!-128)/100
  BoxObj(i+5)=(GrnC2!-128)/100
  BoxObj(i+6)=-(BleC3!-128)/100
  BoxObj(i+7)=(RedC3!-128)/100
  BoxObj(i+8)=(GrnC3!-128)/100
  BoxObj(i+9)=-(BleC4!-128)/100
  BoxObj(i+10)=(RedC4!-128)/100
  BoxObj(i+11)=(GrnC4!-128)/100
ELSE
  BoxObj(i)=-(BleC!*reduce)+dxfXcenter
  BoxObj(i+1)=(RedC!*reduce)-.5
  BoxObj(i+2)=(GrnC!*reduce)-dxfYcenter
  BoxObj(i+3)=-(BleC2!*reduce)+dxfXcenter
  BoxObj(i+4)=(RedC2!*reduce)-.5
  BoxObj(i+5)=(GrnC2!*reduce)-dxfYcenter
  BoxObj(i+6)=-(BleC3!*reduce)+dxfXcenter
  BoxObj(i+7)=(RedC3!*reduce)-.5
  BoxObj(i+8)=(GrnC3!*reduce)-dxfYcenter
  BoxObj(i+9)=-(BleC4!*reduce)+dxfXcenter
  BoxObj(i+10)=(RedC4!*reduce)-.5
  BoxObj(i+11)=(GrnC4!*reduce)-dxfYcenter
END IF
  i=i+12
'---------------------------
  DXFCod%=VAL(DXFf.ReadLine)
 RETURN
END SUB

SUB OpenBMP
 OpenDlog.Filter="*.BMP|*.BMP"
 IF OpenDlog.Execute THEN
  Texture$=OpenDlog.FileName : Texture%=GL.CreateTextureFromFile(Texture$)
 END IF
END SUB

sub ZoomP
 qqaa :
 getmouse=1 : doevents 
 if getmouse then
  DoEvents : distance=distance +.005 : elev=elev-.0025 : DoEvents : redraw : goto qqaa
 end if
 flagF=SetFocus(panel.handle)
end sub

sub ZoomM
 qqa :
 getmouse=1 : doevents 
 if getmouse then
  DoEvents : distance=distance -.005 : elev=elev+.0025 : DoEvents : redraw : goto qqa
 end if
 flagF=SetFocus(panel.handle)
end sub

sub elP
 qq :
 getmouse=1 : doevents 
 if getmouse then
  DoEvents : xrot=xrot-.15 : DoEvents : redraw : goto qq
 end if
 flagF=SetFocus(panel.handle)
end sub

sub elM
 qqq :
 getmouse=1 : doevents 
 if getmouse then
  DoEvents : xrot=xrot+.15 : DoEvents : redraw : goto qqq
 end if
 flagF=SetFocus(panel.handle)
end sub

sub LetMouse
 getmouse=0
end sub

sub stpr
 stopper=stopper*-1 : flagF=SetFocus(panel.handle)
end sub

sub strt
 RotV=RotV*-1 : flagF=SetFocus(panel.handle)
end sub

SUB LoadTGA
 TGAf.Open(TGALoaded$,0) : TGAf.ReadUDT(MyTGA)
 IF MyTGA.bits<>Chr$(&h20) THEN
  FOR Py%=0 to 127 
   FOR Px%=0 to 127
    BleC!=(asc(TGAf.ReadStr(1))-128)/100
    GrnC!=(asc(TGAf.ReadStr(1))-128)/100
    RedC!=(asc(TGAf.ReadStr(1))-128)/100
    Pnt(Px%).Bz(Py%)=BleC!
    Pnt(Px%).Gy(Py%)=GrnC!       
    Pnt(Px%).Rx(Py%)=RedC!
   NEXT
   'fix rapidq unable to fill
   BleC!=Pnt(0).Bz(Py%)
   GrnC!=Pnt(0).Gy(Py%)
   RedC!=Pnt(0).Rx(Py%)
   Pnt(128).Bz(Py%)=BleC!
   Pnt(128).Gy(Py%)=GrnC!
   Pnt(128).Rx(Py%)=RedC!
  NEXT
  FOR Px%=0 to 128
   'fix rapidq unable to fill
   BleC!=Pnt(Px%).Bz(127)
   GrnC!=Pnt(Px%).Gy(127)
   RedC!=Pnt(Px%).Rx(127)
   Pnt(Px%).Bz(128)=BleC!
   Pnt(Px%).Gy(128)=GrnC!
   Pnt(Px%).Rx(128)=RedC!
  NEXT
  TGAf.close : initnum=1024
  FOR Py%=0 TO 31
   FOR Px%=0 to 31 
    BoxObj(px%*12+py%*384)=Pnt(Px%*4).Gy(Py%*4)
    BoxObj((px%*12+py%*384)+1)=Pnt(Px%*4).Bz(Py%*4)
    BoxObj((px%*12+py%*384)+2)=Pnt(Px%*4).Rx(Py%*4)
    BoxObj((px%*12+py%*384)+3)=Pnt(Px%*4+4).Gy(Py%*4)
    BoxObj((px%*12+py%*384)+4)=Pnt(Px%*4+4).Bz(Py%*4)
    BoxObj((px%*12+py%*384)+5)=Pnt(Px%*4+4).Rx(Py%*4)
    BoxObj((px%*12+py%*384)+6)=Pnt(Px%*4+4).Gy(Py%*4+4)
    BoxObj((px%*12+py%*384)+7)=Pnt(Px%*4+4).Bz(Py%*4+4)
    BoxObj((px%*12+py%*384)+8)=Pnt(Px%*4+4).Rx(Py%*4+4)
    BoxObj((px%*12+py%*384)+9)=Pnt(Px%*4).Gy(Py%*4+4)
    BoxObj((px%*12+py%*384)+10)=Pnt(Px%*4).Bz(Py%*4+4)
    BoxObj((px%*12+py%*384)+11)=Pnt(Px%*4).Rx(Py%*4+4)
   NEXT
  NEXT
 END IF
END SUB

SUB LoadTGAd
 OpenDlog.Filter="*.TGA|*.TGA"
 IF OpenDlog.Execute THEN
  TGALoaded$=OpenDlog.FileName : DoEvents : LoadTGA : DoEvents : MakeMods
 END IF
END SUB

SUB LoadDXFd
 OpenDlog.Filter="*.DXF|*.DXF"
 IF OpenDlog.Execute THEN
  DXFLoaded$=OpenDlog.FileName : TGALoaded$="" : DoEvents : MakeMods
 END IF
END SUB

SUB Refr
 DoEvents : Texture%=GL.CreateTextureFromFile(Texture$)
 DoEvents : MakeMods : flagF=SetFocus(panel.handle)
END SUB

SUB Rest
 yrot=0.5 : xrot=0.0 : yrot=0.0 : distance=-3.5 : elev=1.75 : flagF=SetFocus(panel.handle)
END SUB

sub Solid
 DoEvents : glpolygonmode(GL_FRONT_AND_BACK,GL_FILL)
 flagF=SetFocus(panel.handle)
END SUB

sub Wire
 DoEvents : glPolygonMode(GL_FRONT_AND_BACK, GL_LINE) : flagF=SetFocus(panel.handle)
END SUB